#define SEGMENT 18432l
#define SEGMENT_WORDS 12288l
#define OFFSET_PATCH 0xfc00l
#define OFFSET_LABEL 0x10c33l
#define OFFSET_TONE 0x10e00l
#define OFFSET_WAVEA 0x12000l
#define OFFSET_WAVEB 0x12000l+18*SEGMENT

#ifndef Byte
#define Byte u_char
#endif

typedef struct {
               char name[8];
               Byte f1;
               Byte sourceTone;		// 0-31
               Byte subToneFlag;	// 1= sub tone
               Byte frequency;  	// 0=30, 1=15 kHz
               Byte origKeyNumber;  // 11-120
               Byte waveBank;		// 0=A, 1=B
               Byte waveStart;		// 0-17 memory units
               Byte waveLen;		// 0-18 memory units
               Byte startPoint[3];	// H M L byte
               Byte endPoint[3];
               Byte loopPoint[3];
               Byte loopMode;		// 0,1,2,3=Fwd,Alt,1Shot,Reverse
               Byte f2[102];
               } TONE;

typedef struct 	patchParameterS330
{       Byte    patchName[12];
        Byte    bendRange;
        Byte    dummy1[1];
        Byte    afterTouchSense;
        Byte    keyMode;
        Byte    velocitySwThreshold;
        Byte    toneToKey1[109];
        Byte    toneToKey2[109];
        Byte    copySource;
        Byte    octaveShift;
        Byte    outputLevel;
        Byte    dummy2[1];
        Byte    detune;
        Byte    velocityMixRatio;
        Byte    afterTouchAssign;
        Byte    keyAssign;
        Byte    outputAssign;
        Byte    dummy3[12];
} patchParameterS330;

typedef struct patchParameterS50
{       Byte    patchName[12];
        Byte    bendRange;
        Byte    dummy1[1];
        Byte    afterTouchSense;
        Byte	dummy2[4];
        Byte    keyMode;
        Byte    velocitySwThreshold;
		Byte	dummy3[19];
        Byte    toneToKey1[128];
        Byte    toneToKey2[128];
        Byte    copySource;
        Byte    octaveShift;
        Byte    outputLevel;
		Byte	modulationDepth;
        Byte    detune;
        Byte    velocityMixRatio;
        Byte    afterTouchAssign;
        Byte    dummy4[209];
} patchParameterS50;

